//  COPYRIGHT:       PrimeObjects Software Inc. (C) 2022 All Right Reserved
//  COMPANY URL:     https://www.primeobjects.com/
//  CONTACT:         developer@primeobjects.com
//
//  This source is subject to the PrimeObjects License Agreements.
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
import React, { useEffect, useState } from "react";
import { getBasicServerSideProps, returnServerSideProps } from "primeobjects-ui-web-application/build/cjs/page/server";
import SiteBasePage from "primeobjects-ui-web-application/build/cjs/page/site-base";
import SitePageSplit from "primeobjects-ui-web-application/build/cjs/sections/site-page-split";
import { isNonEmptyString } from "primeobjects-helper-util";
import { callApiBase } from "primeobjects-ui-web-application/build/cjs/util";
import axios from "axios";
import { SignUpForm as SignUpFormInternal } from "./forms/sign-up";
import { SignInForm as SignInFormInternal } from "./forms/sign-in";
import { SignUpSection as SignUpSectionInternal } from "./sections/sign-up";
import { SignInSection as SignInSectionInternal } from "./sections/sign-in";
export var getServerSidePropsForAuthPage = function (props) { return __awaiter(void 0, void 0, void 0, function () {
    var basicServerSideProps, query, solution, action, token, result, data, _a, error_1;
    return __generator(this, function (_b) {
        switch (_b.label) {
            case 0: return [4 /*yield*/, getBasicServerSideProps(__assign({}, props))];
            case 1:
                basicServerSideProps = _b.sent();
                query = basicServerSideProps.query, solution = basicServerSideProps.solution;
                action = (query === null || query === void 0 ? void 0 : query.action) ? query === null || query === void 0 ? void 0 : query.action : "";
                token = (query === null || query === void 0 ? void 0 : query.token) ? query === null || query === void 0 ? void 0 : query.token : "";
                result = (query === null || query === void 0 ? void 0 : query.result) ? query === null || query === void 0 ? void 0 : query.result : "";
                data = {};
                _a = action;
                switch (_a) {
                    case "activate-with-password": return [3 /*break*/, 2];
                    case "activate-without-password": return [3 /*break*/, 2];
                    case "activate-reset-password": return [3 /*break*/, 2];
                }
                return [3 /*break*/, 6];
            case 2:
                if (!isNonEmptyString(token)) return [3 /*break*/, 6];
                _b.label = 3;
            case 3:
                _b.trys.push([3, 5, , 6]);
                return [4 /*yield*/, callApiBase("".concat(solution.apis.organization, "parse-verification-token"), 
                    // "http://localhost:3000/prod/parse-verification-token",
                    {
                        token: token
                    }, "POST", { solutionId: solution.id })];
            case 4:
                //console.log(token);
                data = _b.sent();
                return [3 /*break*/, 6];
            case 5:
                error_1 = _b.sent();
                console.log(error_1);
                return [3 /*break*/, 6];
            case 6: return [2 /*return*/, returnServerSideProps(__assign(__assign({}, basicServerSideProps), { action: action, result: result, data: data }))];
        }
    });
}); };
export var AuthPage = function (props) {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m;
    var solution = props.solution, url = props.url, host = props.host, domain = props.domain, result = props.result, data = props.data, action = props.action, port = props.port, coverImageAlt = props.coverImageAlt, coverImageUrl = props.coverImageUrl, coverImageLocation = props.coverImageLocation, coverImageBackgroundSize = props.coverImageBackgroundSize;
    var SignInSection = (_a = props.SignInSection) !== null && _a !== void 0 ? _a : SignInSectionInternal;
    var SignUpSection = (_b = props.SignUpSection) !== null && _b !== void 0 ? _b : SignUpSectionInternal;
    var SignInForm = (_c = props.SignInForm) !== null && _c !== void 0 ? _c : SignInFormInternal;
    var SignUpForm = (_d = props.SignUpForm) !== null && _d !== void 0 ? _d : SignUpFormInternal;
    var _o = useState(undefined), signUpAgreement = _o[0], setSignUpAgreement = _o[1];
    useEffect(function () {
        var _a, _b;
        var agreement = (_a = props.signUpAgreement) !== null && _a !== void 0 ? _a : (_b = solution === null || solution === void 0 ? void 0 : solution.signUp) === null || _b === void 0 ? void 0 : _b.agreement;
        if (isNonEmptyString(agreement === null || agreement === void 0 ? void 0 : agreement.content)) {
            setSignUpAgreement(agreement);
        }
        else {
            if (agreement === null || agreement === void 0 ? void 0 : agreement.url) {
                axios({ url: agreement === null || agreement === void 0 ? void 0 : agreement.url }).then(function (result) {
                    setSignUpAgreement(__assign(__assign({}, agreement), { content: result.data }));
                });
            }
        }
    }, [solution.id]);
    // console.log({ AuthPage: data });
    var getTitle = function () {
        switch (action) {
            case "activate-reset-password": {
                return "Reset Password";
            }
            case "activate-without-password": {
                return "Activate User Account";
            }
            case "activate-reset-password": {
                return "Sign Up";
            }
            case "reset-password": {
                return "Reset Password";
            }
            case "sign-up": {
                return "Sign Up";
            }
            default: {
                return "Sign In";
            }
        }
    };
    var renderComponent = function () {
        switch (action) {
            case "sign-up": {
                return (React.createElement(SignUpSection, __assign({}, props, { SignUpForm: SignUpForm, agreement: signUpAgreement }), props.children));
            }
            default: {
                return (React.createElement(SignInSection, __assign({}, props, { SignInForm: SignInForm, data: __assign({ action: action, result: result }, data) }), props.children));
            }
        }
    };
    return (React.createElement(SiteBasePage, __assign({}, props, { solution: solution, headProps: { host: host, url: url, title: getTitle(), domain: domain, port: port } }),
        React.createElement(SitePageSplit, { coverImageAlt: coverImageAlt
                ? coverImageAlt
                : (_f = (_e = solution.site) === null || _e === void 0 ? void 0 : _e.authPage) === null || _f === void 0 ? void 0 : _f.coverImageAlt, coverImageUrl: coverImageUrl
                ? coverImageUrl
                : (_h = (_g = solution.site) === null || _g === void 0 ? void 0 : _g.authPage) === null || _h === void 0 ? void 0 : _h.coverImageUrl, coverImageLocation: coverImageLocation
                ? coverImageLocation
                : (_k = (_j = solution.site) === null || _j === void 0 ? void 0 : _j.authPage) === null || _k === void 0 ? void 0 : _k.coverImageLocation, coverImageBackgroundSize: coverImageBackgroundSize
                ? coverImageBackgroundSize
                : (_m = (_l = solution.site) === null || _l === void 0 ? void 0 : _l.authPage) === null || _m === void 0 ? void 0 : _m.coverImageBackgroundSize },
            renderComponent(),
            props.children)));
};
export default AuthPage;
//# sourceMappingURL=auth-page.js.map