//  COPYRIGHT:       PrimeObjects Software Inc. (C) 2022 All Right Reserved
//  COMPANY URL:     https://www.primeobjects.com/
//  CONTACT:         developer@primeobjects.com
//
//  This source is subject to the PrimeObjects License Agreements.
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
import React, { useState, useEffect } from "react";
import { sendMessage } from "primeobjects-ui-web-store/build/cjs/center/message";
import { AuthSectionLink } from "./util";
import { callApiBase, getApiEndpoint } from "primeobjects-ui-web-application/build/cjs/util";
import { getPrimaryColor } from "primeobjects-helper-ui";
import SVG from "primeobjects-ui-web-basic/build/cjs/controls/svg";
import { signIn } from "primeobjects-ui-web-application/build/cjs/context/auth-cognito";
import { useRouter } from "next/navigation";
import { appTrackIsOn, isEmail, getWindow, isNonEmptyString } from "primeobjects-helper-util/build/cjs/core";
import Lottie from "primeobjects-ui-web-basic/build/cjs/controls/lottie";
import { getLocalStorage, setLocalStorage, setCookie } from "primeobjects-ui-web-basic";
export var SignInSection = function (props) {
    var _a, _b;
    var router = useRouter();
    var supportSSO = props.supportSSO, SignInForm = props.SignInForm, message = props.message, solution = props.solution;
    var _c = useState(""), doing = _c[0], setDoing = _c[1];
    var _d = useState(""), errorMessage = _d[0], setErrorMessage = _d[1];
    var _e = useState({}), data = _e[0], setData = _e[1];
    var type = data.type == "mobile" ? "mobile" : "email";
    var primaryColor = getPrimaryColor(solution);
    var buttonColorName = props.buttonColorName
        ? props.buttonColorName
        : primaryColor.name;
    useEffect(function () {
        var _a;
        var rememberMe = getLocalStorage("remember-me", "");
        var newData = __assign(__assign({ email: ((_a = props.data) === null || _a === void 0 ? void 0 : _a.action) == "sign-in" ? rememberMe : "" }, props.data), { rememberMe: isNonEmptyString(rememberMe) });
        setData(newData);
    }, [props.data]);
    var getButtonTitle = function () {
        switch (data.action) {
            case "reset-password":
                return "Send password reset code";
            default:
                return "Submit";
        }
    };
    var getTitle = function () {
        switch (data.action) {
            case "activate-with-password":
                return "Activate your account";
            case "activate-without-password":
                return "Activate your account";
            case "activate-reset-password":
                return "Reset your password";
            case "reset-password":
                return "Reset your password";
            default:
                return "Sign in to your account";
        }
    };
    var onChangeData = function (newData) {
        setData(newData);
        setErrorMessage("");
        if (props.onChangeData)
            props.onChangeData(newData);
    };
    var onClickResetPassword = function () {
        if (props.onClickResetPassword) {
            props.onClickResetPassword(data);
        }
        else {
            router.push("/auth/reset-password");
        }
    };
    var onClickResendCodes = function (data) {
        sendVerificationToken(data.action, "Sending new verification code ...", "Failed to send new verification code.");
    };
    var onSignInError = function (error) {
        setDoing("");
        setErrorMessage(error);
        if (props.onSignInError)
            props.onSignInError(error);
    };
    var onSubmit = function () {
        setData(__assign(__assign({}, data), { codeSent: "" }));
        if (data.rememberMe) {
            setLocalStorage("remember-me", data.email);
        }
        else {
            setLocalStorage("remember-me", "");
        }
        switch (data.action) {
            case "activate-with-password": {
                onActivateUserWithPassword();
                break;
            }
            case "activate-without-password": {
                onActivateUserWithoutPassword();
                break;
            }
            case "activate-reset-password": {
                onActivateUserWithPassword();
                break;
            }
            case "reset-password": {
                sendVerificationToken("activate-reset-password", "Sending password reset code ...", "Failed to send password reset code.");
                break;
            }
            default: {
                onSignIn();
                break;
            }
        }
    };
    var sendVerificationToken = function (action, doingMessage, errorMessage) {
        (function () { return __awaiter(void 0, void 0, void 0, function () {
            return __generator(this, function (_a) {
                if (!isEmail(data.email)) {
                    return [2 /*return*/, setErrorMessage("Please provide a valid email.")];
                }
                setErrorMessage("");
                setDoing(doingMessage);
                callApiBase(getApiEndpoint(solution, "organization", "send-verification-token"), 
                //"http://localhost:3000/prod/send-verification-token",
                {
                    type: data.type,
                    email: data.email,
                    action: action
                }, "POST", { solutionId: solution.id })
                    .then(function (res) {
                    if (res === null || res === void 0 ? void 0 : res.token) {
                        if (props.onSendVerificationSuccess) {
                            props.onSendVerificationSuccess(data, action);
                        }
                        else {
                            setCookie("sign-in-email", data.email);
                            switch (action) {
                                case "reset-password": {
                                    window.location.href = "/auth/activate-with-password?result=send-verification-success&ts=".concat(Date.now());
                                    break;
                                }
                                case "activate-without-password": {
                                    window.location.href = "/auth/activate-without-password?result=send-verification-success&ts=".concat(Date.now());
                                    break;
                                }
                                default: {
                                    window.location.href = "/auth/activate-reset-password?result=send-verification-success&ts=".concat(Date.now());
                                    break;
                                }
                            }
                        }
                    }
                    else {
                        setErrorMessage("Sorry, we can not send the verification token now, please try again later.");
                    }
                })
                    .catch(function (error) {
                    if (appTrackIsOn())
                        console.error({ error: error });
                    setErrorMessage(errorMessage);
                })
                    .finally(function () {
                    setDoing("");
                });
                return [2 /*return*/];
            });
        }); })();
    };
    var onSignInSuccess = function () {
        if (props.onSignInSuccess) {
            props.onSignInSuccess(data);
        }
        {
            getWindow().location.replace("/list/dashboard?ts=".concat(Date.now()));
        }
        return true;
    };
    var onClickSignUp = function () {
        if (props.onClickSignUp) {
            props.onClickSignUp(data);
        }
        else {
            router.push("/auth/sign-up");
        }
    };
    var onClickSignIn = function () {
        setData(__assign(__assign({}, data), { action: "sign-in" }));
    };
    var onActivateUserWithoutPassword = function () {
        if (!data.code || (data.code && data.code.length != 8)) {
            return setErrorMessage("Please provide valid verification code.");
        }
        setErrorMessage("");
        setDoing("Processing ...");
        callApiBase("".concat(solution.apis.organization, "activate-user-without-password"), data, "POST", { solutionId: solution.id })
            .then(function (res) {
            if (res.result == true) {
                if (props.onActivateUserWithoutPasswordSuccess) {
                    props.onActivateUserWithoutPasswordSuccess(data);
                }
                else {
                    router.push("/auth/sign-in?result=activate-user-without-password-success");
                }
            }
            else {
                setErrorMessage("Please provide valid verification code. If you have verified your account with the code, please click sign in link below to sign in.");
            }
        })
            .catch(function (error) {
            if (appTrackIsOn())
                console.error({ error: error });
            setErrorMessage("Failed to activate user.");
        })
            .finally(function () {
            setDoing("");
        });
    };
    var onActivateUserWithPassword = function () {
        if (!data.code || (data.code && data.code.length != 8)) {
            return setErrorMessage("Please provide valid verification code.");
        }
        if (data.password != data.confirmPassword) {
            return setErrorMessage("Your password and confirmation password do not match.");
        }
        setErrorMessage("");
        setDoing("Processing ...");
        callApiBase("".concat(solution.apis.organization, "activate-user-with-password"), __assign({ userId: data.email }, data), "POST", { solutionId: solution.id })
            .then(function (res) {
            if (res.result) {
                if (props.onActivateUserWithPasswordSuccess) {
                    props.onActivateUserWithPasswordSuccess(data);
                }
                else {
                    router.push("/auth/sign-in?result=activate-user-with-password-success");
                }
            }
            else {
                setErrorMessage("Please provide valid verification code.");
            }
        })
            .catch(function (error) {
            if (appTrackIsOn())
                console.error({ error: error });
            setErrorMessage("Failed to activate user.");
        })
            .finally(function () {
            setDoing("");
        });
    };
    var onSignIn = function () {
        setErrorMessage("");
        setDoing("Processing ...");
        try {
            //try sign in by the user
            signIn(solution, data, { type: type })
                .then(function (result) {
                var _a;
                if (result) {
                    if (result.error) {
                        switch (result.error) {
                            case "ERROR_API_AUTH_USER_ORGS_VERIFICATION_FAILED": {
                                setData(__assign(__assign({}, data), { action: "activate-with-password" }));
                                return onSignInError("The email verification failed. Please provide a correct verification code above.");
                            }
                            case "ERROR_SIGN_IN_NEED_VERIFY": {
                                setData(__assign(__assign({}, data), { action: "activate-with-password" }));
                                return onSignInError("The user's email was not verified yet. Please provide your verification code above.");
                            }
                            case "ERROR_SIGN_IN_NEED_EMAIL": {
                                return onSignInError("Please provide a valid email.");
                            }
                            case "ERROR_SIGN_IN_NEED_PASSWORD": {
                                return onSignInError("Please provide a valid password.");
                            }
                            case "ERROR_SIGN_IN_USER_NOT_FOUND": {
                                return onSignInError("The user does not exist.");
                            }
                            case "ERROR_SIGN_IN_COGNITO": {
                                switch ((_a = result === null || result === void 0 ? void 0 : result.detail) === null || _a === void 0 ? void 0 : _a.message) {
                                    case "Password attempts exceeded": {
                                        return onSignInError("The user account was locked because the password attempts exceeded. Please use \"Forgot your password\" link below to reset your password.");
                                    }
                                    default: {
                                        return onSignInError("Incorrect email or password.");
                                    }
                                }
                            }
                            default: {
                                return onSignInError("Failed to sign in.");
                            }
                        }
                    }
                    sendMessage("context-sign-in-success", "action", result);
                    onSignInSuccess();
                }
                else {
                    onSignInError("Failed to sign in.");
                }
            })
                .catch(function (error) {
                console.error({ error1: error });
                onSignInError("Failed to sign in.");
            });
        }
        catch (error) {
            console.error({ error2: error });
            onSignInError("Failed to sign in.");
        }
    };
    var renderSSO = function () {
        return (supportSSO && (React.createElement(React.Fragment, null,
            React.createElement("div", { className: "relative flex space-x-3" },
                React.createElement("div", { className: "h-8 w-8 rounded-full bg-green-500 flex flex- items-center justify-center ring-8 ring-white" },
                    React.createElement("svg", { className: "h-5 w-5 text-white", "x-description": "Heroicon name: solid/check", xmlns: "http://www.w3.org/2000/svg", viewBox: "0 0 20 20", fill: "currentColor", "aria-hidden": "true" },
                        React.createElement("path", { fillRule: "evenodd", d: "M16.707 5.293a1 1 0 010 1.414l-8 8a1 1 0 01-1.414 0l-4-4a1 1 0 011.414-1.414L8 12.586l7.293-7.293a1 1 0 011.414 0z", clipRule: "evenodd" }))),
                React.createElement("div", { className: "min-w-0 flex-1 pt-1.5 flex justify-between space-x-4" },
                    React.createElement("span", { className: "text-base" }, "Sign in with social accounts"))),
            React.createElement("div", { className: "mt-5 mb-10 py-10 pl-8 border-0 border-l ml-3" },
                React.createElement("button", { style: { maxWidth: 250 }, className: "mb-5 w-full flex justify-center py-2 px-4 border border-transparent rounded-md shadow-sm text-sm font-medium bg-gray-100 hover:bg-gray-200 focus:outline-none focus:ring-2 focus:ring-offset-2 focus:ring-".concat(buttonColorName, "-500") },
                    React.createElement(SVG, { src: "/icons/logo-google.svg", className: "flex justify-center", style: { width: 20, marginRight: 10 } }),
                    "Google"),
                React.createElement("button", { style: { maxWidth: 250 }, className: "mb-5 w-full flex justify-center py-2 px-4 border border-transparent rounded-md shadow-sm text-sm font-medium bg-gray-100 hover:bg-gray-200 focus:outline-none focus:ring-2 focus:ring-offset-2 focus:ring-".concat(buttonColorName, "-500") },
                    React.createElement(SVG, { src: "/icons/logo-facebook.svg", className: "flex justify-center", style: { width: 20, marginRight: 10 } }),
                    "Facebook")))));
    };
    return (React.createElement("div", { className: "mx-auto w-full max-w-md lg:w-96 ".concat(props.wrapperClassName ? props.wrapperClassName : ""), style: props.wrapperStyle ? props.wrapperStyle : {} },
        message && React.createElement("div", { className: "w-full" }, message),
        React.createElement("div", null,
            React.createElement("h2", { className: "mt-6 text-3xl font-extrabold text-gray-900" }, getTitle())),
        React.createElement("div", { className: "mt-8" },
            renderSSO(),
            supportSSO && (React.createElement("div", { className: "relative flex space-x-3" },
                React.createElement("div", { className: "h-8 w-8 rounded-full bg-green-500 flex flex- items-center justify-center ring-8 ring-white" },
                    React.createElement("svg", { className: "h-5 w-5 text-white", "x-description": "Heroicon name: solid/check", xmlns: "http://www.w3.org/2000/svg", viewBox: "0 0 20 20", fill: "currentColor", "aria-hidden": "true" },
                        React.createElement("path", { fillRule: "evenodd", d: "M16.707 5.293a1 1 0 010 1.414l-8 8a1 1 0 01-1.414 0l-4-4a1 1 0 011.414-1.414L8 12.586l7.293-7.293a1 1 0 011.414 0z", clipRule: "evenodd" }))),
                React.createElement("div", { className: "min-w-0 flex-1 pt-1.5 flex justify-between space-x-4" },
                    React.createElement("span", { className: "text-base" }, "Or sign in with your email")))),
            React.createElement("div", { className: supportSSO
                    ? "mt-5 py-10 pl-8 border-0 border-l ml-3"
                    : "py-6" },
                React.createElement(SignInForm, { message: message, data: data, onClickResendCodes: onClickResendCodes, onChangeData: onChangeData, solution: solution, alwaysShowLabel: true, errorMessage: errorMessage, onSubmitPassword: onSubmit, doing: doing }, props.children),
                doing && (React.createElement("div", { className: "w-full" },
                    React.createElement("div", { style: {
                            width: 50,
                            height: 50
                        } },
                        React.createElement(Lottie, { className: "w-full h-full", url: "/icons/platform/lottie/dots-2.json", colors: Array(6).fill(primaryColor["600"]) })))),
                !doing && (React.createElement("button", { className: "my-8 flex justify-center py-2 px-4 border border-transparent rounded-md shadow-sm text-sm font-medium text-white bg-".concat(buttonColorName, "-600 hover:bg-").concat(buttonColorName, "-700"), onClick: onSubmit }, getButtonTitle())),
                !doing && ((_a = solution === null || solution === void 0 ? void 0 : solution.site) === null || _a === void 0 ? void 0 : _a.supportSignUp) != false && (React.createElement(AuthSectionLink, { text: "Register for a Free Account.", colorName: "emerald", onClick: onClickSignUp })),
                !doing &&
                    ((_b = solution === null || solution === void 0 ? void 0 : solution.site) === null || _b === void 0 ? void 0 : _b.supportSignUp) != false &&
                    data.action == "reset-password" && (React.createElement(AuthSectionLink, { text: "Have a user account already? Click here to sign in.", onClick: onClickSignIn })),
                !doing && data.action == "activate-without-password" && (React.createElement(AuthSectionLink, { text: "Already verified your account? Click here to sign in.", onClick: onClickSignIn })),
                !doing && data.action != "reset-password" && (React.createElement(AuthSectionLink, { text: "Forgot your password? Click here to reset.", onClick: onClickResetPassword }))))));
};
export default SignInSection;
//# sourceMappingURL=sign-in.js.map